// IShopServiceListener.aidl
package com.picsart.shopNew.lib_shop.callback;

// Declare any non-default types here with import statements
import com.picsart.shopNew.lib_shop.domain.ShopItem;

interface IShopServiceListener {

   void onShopItemAdded(in ShopItem shopItem);
   void onShopItemsListChanged(in List<ShopItem> newItems);
   void onShopItemPriceReady(in ShopItem shopItem);
   void onShopItemUpdated(in ShopItem shopItem);
}
