
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int _mode;

static uchar md(const uchar4* p){
	return p->r / 3 + p->g / 2 + p->b / 10;
}

static uchar mr(const uchar4* p){
	return p->r;
}

static uchar mg(const uchar4* p){
	return p->g;
}

static uchar mb(const uchar4* p){
	return p->b;
}

void set_params_blackandwhite(int mode) {
    /*
    switch (mode) {
    default:
    case 0: pf = md; break;
    case 1: pf = mr; break;
    case 2: pf = mg; break;
    case 3: pf = mb; break;
    }
    */
    _mode = mode;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
	uchar graypixel;
    //uchar graypixel = (*pf)(v_in);
	switch (_mode)
	{
        default:
        case 0: graypixel = md(v_in); break;
        case 1: graypixel = mr(v_in); break;
        case 2: graypixel = mg(v_in); break;
        case 3: graypixel = mb(v_in); break;
    }
    *v_out = (uchar4){graypixel, graypixel, graypixel, 255};
}

