
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    int tr = v_in->r;
    int tg = v_in->g;
    int tb = v_in->b;

    int r = v_out->r;
    int g = v_out->g;
    int b = v_out->b;

    // 50% soft light
    {
        tr = r - (255 - 2 * tr) * r * (255 - r) / 65025;
        tg = g - (255 - 2 * tg) * g * (255 - g) / 65025;
        tb = b - (255 - 2 * tb) * b * (255 - b) / 65025;

        r = (tr + r) / 2;
        g = (tg + g) / 2;
        b = (tb + b) / 2;
    }

    *v_out = (uchar4){r, g, b, 255};
}
