
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar lut[256];

void init() {
	for(int x = 0; x < 256; ++x)
		lut[x] = 255 - (255 - x) * (255 - x) / 255;
}

void root(const uchar4 *v_in, uchar4 *v_out) {
	*v_out = (uchar4) { lut[v_in->r],
						lut[v_in->g],
						lut[v_in->b],
						255 };
}
