
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation blured_data;
static int ifade, ofade;

void set_params_soften(rs_allocation blured, int fade) {
    blured_data = blured;

    ifade = fade;
    ofade = 100 - fade;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4* bp = getUChar4(blured_data, y, x);
    *v_out = (uchar4){  (v_in->r * ifade + bp->r * ofade) / 100,
                        (v_in->g * ifade + bp->g * ofade) / 100,
                        (v_in->b * ifade + bp->b * ofade) / 100,
                        255  };
}
