
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation top, bottom;
static int W, H, ialpha, oalpha;

void set_params_utils_const_alpha_blend(rs_allocation top_alloc, rs_allocation bottom_alloc, int alpha) {
    W = rsAllocationGetDimX(top_alloc);
    H = rsAllocationGetDimY(top_alloc);

    top = top_alloc;
    bottom = bottom_alloc;

    ialpha = alpha;
    oalpha = 255 - ialpha;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 t = getValUChar4(top, y, x);
    const uchar4 b = getValUChar4(bottom, y, x);

    *v_out = (uchar4){  (t.r * ialpha + b.r * oalpha) / 255,
                        (t.g * ialpha + b.g * oalpha) / 255,
                        (t.b * ialpha + b.b * oalpha) / 255,
                        255  };
}
