#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

//#include "rs_utils.rsh"

static int threshold_lm;
static int threshold_rm;
static int multi;

void set_params_RGBA_to_YUV(int tlm, int trm, int m)
{
	threshold_lm = 255 - tlm;
	threshold_rm = 255 - trm;
	multi = m;
}

void root(const uchar4 *v_in, int3 *v_out, uint32_t x, uint32_t y)
{
	float temp = 0.299 * v_in->r + 0.587 * v_in->g + 0.114 * v_in->b;

	v_out->s0 = (int) (temp > threshold_lm && temp <= threshold_rm ? temp * multi : temp);
	v_out->s1 = (int) (0.436 * (v_in->b - temp)/(1 - 0.114) + 128);
	v_out->s2 = (int) (0.615 * (v_in->r - temp)/(1 - 0.299) + 128);
}
