
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation source, blured;

void set_params_utils_pst_high_pass_filter(rs_allocation source_alloc, rs_allocation blured_alloc) {
    source = source_alloc;
    blured = blured_alloc;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 sp = getValUChar4(source, y, x);
    const uchar4 bp = getValUChar4(blured, y, x);
    *v_out = (uchar4){  SATURATE_CAST_TO_UCHAR(128 + sp.r - bp.r),
                        SATURATE_CAST_TO_UCHAR(128 + sp.g - bp.g),
                        SATURATE_CAST_TO_UCHAR(128 + sp.b - bp.b),
                        255  };
}
