
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int radius;

void set_params_halftonedots_1(int rad) {
    radius = rad;
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
	int X = x / radius;
	int Y = y / radius;

	int color = ( ((X % 2 == 0) && (Y % 2 == 0)) || ( (X % 2 != 0) && (Y % 2 != 0) )) ? 255 : 200;

	int gray = color * (*v_out) / 200;
	gray = (gray > 255) ? 255 : gray;

	*v_out = (uchar) gray;
}
