
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation gray;
static float c;

void set_params_halftonedots_2(rs_allocation img_gray, int contr) {
    gray = img_gray;
    c = contr / 25.f;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
	uchar cur_gray = getValUChar(gray, y, x);

	int r = v_in->r + (cur_gray - 128.f) * c;
	int g = v_in->g + (cur_gray - 128.f) * c;
	int b = v_in->b + (cur_gray - 128.f) * c;

	*v_out = (uchar4) {	SATURATE_CAST_TO_UCHAR(r),
						SATURATE_CAST_TO_UCHAR(g),
						SATURATE_CAST_TO_UCHAR(b),
						255 };
}
