
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation blr;
static float unsharp2;

void set_params_hdr_1(rs_allocation blur, float unsharp) {
    blr = blur;
    unsharp2 = unsharp * 2;
}

void root(const uchar4 *v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
	uchar4 * cur = getUChar4(blr, y, x);
	int r = (v_in->r - cur->r) * unsharp2 + v_in->r;
	int g = (v_in->g - cur->g) * unsharp2 + v_in->g;
	int b = (v_in->b - cur->b) * unsharp2 + v_in->b;
	*v_out = (uchar4) {	(r > 255) ? 255 : (r < 0) ? 0 : r,
						(g > 255) ? 255 : (g < 0) ? 0 : g,
						(b > 255) ? 255 : (b < 0) ? 0 : b,
						255 };
}
