
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static uchar4 cc, cf;

void set_params_sketcher_2(int color_contour, int color_fill) {
    cc.r = (color_contour >> 16) & 255;
    cc.g = (color_contour >> 8) & 255;
    cc.b = (color_contour) & 255;

    cf.r = (color_fill >> 16) & 255;
    cf.g = (color_fill >> 8) & 255;
    cf.b = (color_fill) & 255;
}

void root(const uchar * v_in, uchar4 *v_out, uint32_t x, uint32_t y) {
	int k2 = *v_in;
	int k1 = 255 - k2;
	*v_out = (uchar4) { (cc.r * k1 + cf.r * k2) / 255,
						(cc.g * k1 + cf.g * k2) / 255,
						(cc.b * k1 + cf.b * k2) / 255,
	 	 	 	 	 	255 };
}
