
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation background, gray;
static uchar red, green, blue;

void set_params_stenciler_2(rs_allocation background_alloc, rs_allocation gray_alloc, int color) {
    background = background_alloc;
    gray = gray_alloc;

    color = 0xffffff - color;
    red = get_red(color);
    green = get_green(color);
    blue = get_blue(color);
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 *bp = getUChar4(background, y, x);
    const uchar gp = getValUChar(gray, y, x);

    *v_out = (uchar4){  SATURATE_CAST_TO_UCHAR(bp->r - red   * gp / 255),
                        SATURATE_CAST_TO_UCHAR(bp->g - green * gp / 255),
                        SATURATE_CAST_TO_UCHAR(bp->b - blue  * gp / 255),
                        255  };
}
