
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int rr;
static int rg;
static int rb;
static int gr;
static int gg;
static int gb;
static int br;
static int bg;
static int bb;

void set_params_utils_apply_color_matrix(int rr_, int rg_, int rb_, int gr_, int gg_, int gb_, int br_, int bg_, int bb_) {
    rr = rr_;
    rg = rg_;
    rb = rb_;
    gr = gr_;
    gg = gg_;
    gb = gb_;
    br = br_;
    bg = bg_;
    bb = bb_;
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    const uchar r = v_in->r;
    const uchar g = v_in->g;
    const uchar b = v_in->b;
    v_out->r = SATURATE_CAST_TO_UCHAR((rr * r + rg * g + rb * b) / 255);
    v_out->g = SATURATE_CAST_TO_UCHAR((gr * r + gg * g + gb * b) / 255);
    v_out->b = SATURATE_CAST_TO_UCHAR((br * r + bg * g + bb * b) / 255);
}
