#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

void root(const uchar4 *v_in, float3 *v_out, uint32_t x, uint32_t y)
{

	float var_R = (float) v_in->r / (float) 255;
 	float var_G = (float) v_in->g / (float) 255;
 	float var_B = (float) v_in->b / (float) 255;

 	if (var_R > (float) 0.04045)
 		var_R = pow(((var_R + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_R = var_R / (float) 12.92;
 	if (var_G > (float) 0.04045)
 		var_G = pow(((var_G + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_G = var_G / (float) 12.92;
 	if (var_B > (float) 0.04045)
 		var_B = pow(((var_B + (float) 0.055) / (float) 1.055), (float) 2.4);
 	else
 		var_B = var_B / (float) 12.92;

 	var_R = var_R * (float) 100;
 	var_G = var_G * (float) 100;
 	var_B = var_B * (float) 100;

 	float XYZ[3];
 	float xyzX = var_R * (float) 0.4124 + var_G * (float) 0.3576
 			+ var_B * (float) 0.1805;
 	float xyzY = var_R * (float) 0.2126 + var_G * (float) 0.7152
 			+ var_B * (float) 0.0722;
 	float xyzZ = var_R * (float) 0.0193 + var_G * (float) 0.1192
 			+ var_B * (float) 0.9505;

 	float var_X = xyzX / (float) 95.047;
 	float var_Y = xyzY / (float) 100.000;
 	float var_Z = xyzZ / (float) 108.883;

 	if (var_X > (float) 0.008856)
 		var_X = pow(var_X, (float) 1 / (float) 3);
 	else
 		var_X = ((float) 7.787 * var_X) + ((float) 16 / (float) 116);
 	if (var_Y > (float) 0.008856)
 		var_Y = pow(var_Y, ((float) 1 / (float) 3));
 	else
 		var_Y = ((float) 7.787 * var_Y) + (float) 16 / (float) 116;
 	if (var_Z > (float) 0.008856)
 		var_Z = pow(var_Z, (float) 1 / (float) 3);
 	else
 		var_Z = ((float) 7.787 * var_Z) + (float) 16 / (float) 116;

 	float CIE_a = (float) 500 * (var_X - var_Y);
 	float CIE_b = (float) 200 * (var_Y - var_Z);
 	
 	v_out->s0 = ((float) 116) * var_Y - (float) 16;
 	v_out->s1 = CIE_a;
 	v_out->s2 = CIE_b;

}


