
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static int W, H;
static int k0;
static int k1;
static int k1k0;
static int cx;
static int cy;
static int diff;
static int v0;

void set_params_utils_draw_circular_gradient_mask(rs_allocation mask, int center_x, int center_y, int inner, int outer,int v0_, int v1) {
    W = rsAllocationGetDimX(mask);
    H = rsAllocationGetDimY(mask);
    cx = center_x * W / 100;
    cy = center_y * H / 100;
    k0 = inner;
    k1 = outer;
    v0 = v0_;
    k1k0 = k1 - k0;
    diff = v1 - v0;
}

void root(uchar *v_out, uint32_t x, uint32_t y) {
    const int dx = x - cx;
    const int dy = y - cy;
    float k = sqrt((float)(dx*dx + dy*dy));
   	k = (k <= k0) ? 0.f : (k >= k1) ? 1.f : ((k - k0) / k1k0);
    *v_out = SATURATE_CAST_TO_UCHAR(v0 + k * diff);
}
