
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation top, bottom, mask;

void set_params_utils_mask_alpha_blend(rs_allocation top_alloc, rs_allocation bottom_alloc, rs_allocation mask_alloc) {
    top = top_alloc;
    bottom = bottom_alloc;
    mask = mask_alloc;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 t = getValUChar4(top, y, x);
    const uchar4 b = getValUChar4(bottom, y, x);
    const int ialpha = getValUChar(mask, y, x);
    const int oalpha = 255 - ialpha;

    *v_out = (uchar4){  (t.r * ialpha + b.r * oalpha) / 255,
                        (t.g * ialpha + b.g * oalpha) / 255,
                        (t.b * ialpha + b.b * oalpha) / 255,
                        255  };
}
