
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils_pst_black_and_white.rsh"

static int coeffs[6];

void set_params_utils_pst_black_and_white(
    int reds,
    int yellows,
    int greens,
    int cyans,
    int blues,
    int magentas)
{
    coeffs[0] = reds;
    coeffs[1] = yellows;
    coeffs[2] = greens;
    coeffs[3] = cyans;
    coeffs[4] = blues;
    coeffs[5] = magentas;
}

void root(const uchar4 *v_in, uchar4 *v_out) {
    uchar gray = pst_black_and_white_pixel(v_in->r, v_in->g, v_in->b, coeffs);

    *v_out = (uchar4){gray, gray, gray, 255};
}
