
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation y_data;
static rs_allocation cr_data;
static rs_allocation cb_data;

void set_params_utils_rgb_to_planar_ycc(rs_allocation dst_y, rs_allocation dst_cr, rs_allocation dst_cb) {
    y_data  = dst_y;
    cr_data = dst_cr;
    cb_data = dst_cb;
}

void root(const uchar4 *v_in, uint32_t x, uint32_t y) {
    const uchar Y = DESCALE(v_in->r * RGB2YCC_C0  +  v_in->g * RGB2YCC_C1  +  v_in->b * RGB2YCC_C2, YCC_SHIFT);
    *getUChar(y_data,  y, x) = Y;
    *getUChar(cr_data, y, x) = DESCALE((v_in->r - Y) * RGB2YCC_C3 + YCC_DELTA, YCC_SHIFT);
    *getUChar(cb_data, y, x) = DESCALE((v_in->b - Y) * RGB2YCC_C4 + YCC_DELTA, YCC_SHIFT);
}
