
#pragma version(1)
#pragma rs java_package_name(com.picsart.effects.rs)

#include "rs_utils.rsh"

static rs_allocation source, blured;
static int amount_doubled;

void set_params_utils_unsharp_mask(rs_allocation source_alloc, rs_allocation blured_alloc, float amount) {
    source = source_alloc;
    blured = blured_alloc;
    amount_doubled = amount * 2 * 255;
}

void root(uchar4 *v_out, uint32_t x, uint32_t y) {
    const uchar4 sp = getValUChar4(source, y, x);
    const uchar4 bp = getValUChar4(blured, y, x);
    *v_out = (uchar4){  SATURATE_CAST_TO_UCHAR((sp.r - bp.r) * amount_doubled / 255 + sp.r),
                        SATURATE_CAST_TO_UCHAR((sp.g - bp.g) * amount_doubled / 255 + sp.g),
                        SATURATE_CAST_TO_UCHAR((sp.b - bp.b) * amount_doubled / 255 + sp.b),
                        255  };
}
